Panda3D

- Main Page
- Packages
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Types | Public Member Functions | Static Public Member Functions

# StencilAttrib Class Reference

A StencilAttrib is a collection of all stencil render states. More...

Inheritance diagram for StencilAttrib:

List of all members.

## Public Types
enum | StencilComparisonFunction { SCFNever = 0, SCFLessThan = 1, SCFEqual = 2, SCFLessThanOrEqual = 3, SCFGreaterThan = 4, SCFNotEqual = 5, SCFGreaterThanOrEqual = 6, SCFAlways = 7 }
enum | StencilMask { SMDefault = -1 }
enum | StencilOperation { SOKeep = 0, SOZero = 1, SOReplace = 2, SOIncrement = 3, SODecrement = 4, SOInvert = 5, SOIncrementSaturate = 6, SODecrementSaturate = 7 }
enum | StencilRenderState { SRSFrontEnable = 0, SRSBackEnable = 1, SRSFrontComparisonFunction = 2, SRSFrontStencilFailOperation = 3, SRSFrontStencilPassZFailOperation = 4, SRSFrontStencilPassZPassOperation = 5, SRSReference = 6, SRSReadMask = 7, SRSWriteMask = 8, SRSBackComparisonFunction = 9, SRSBackStencilFailOperation = 10, SRSBackStencilPassZFailOperation = 11, SRSBackStencilPassZPassOperation = 12, SRSClear = 13, SRSClearValue = 14, SRSTotal = 15, SRSFirst = 0 }
## Public Member Functions
unsigned int | getRenderState (unsigned int render_state_identifier)
| Returns render state.
## Static Public Member Functions
static int | getClassSlot ()
static TypeHandle | getClassType ()
static RenderAttrib const | make (unsigned int front_enable, unsigned int front_comparison_function, unsigned int stencil_fail_operation, unsigned int stencil_pass_z_fail_operation, unsigned int front_stencil_pass_z_pass_operation, unsigned int reference, unsigned int read_mask, unsigned int write_mask)
| Constructs a front face StencilAttrib.
static RenderAttrib const | make2Sided (unsigned int front_enable, unsigned int back_enable, unsigned int front_comparison_function, unsigned int stencil_fail_operation, unsigned int stencil_pass_z_fail_operation, unsigned int front_stencil_pass_z_pass_operation, unsigned int reference, unsigned int read_mask, unsigned int write_mask, unsigned int back_comparison_function, unsigned int back_stencil_fail_operation, unsigned int back_stencil_pass_z_fail_operation, unsigned int back_stencil_pass_z_pass_operation)
| Constructs a two-sided StencilAttrib.
static RenderAttrib const | make2SidedWithClear (unsigned int front_enable, unsigned int back_enable, unsigned int front_comparison_function, unsigned int stencil_fail_operation, unsigned int stencil_pass_z_fail_operation, unsigned int front_stencil_pass_z_pass_operation, unsigned int reference, unsigned int read_mask, unsigned int write_mask, unsigned int back_comparison_function, unsigned int back_stencil_fail_operation, unsigned int back_stencil_pass_z_fail_operation, unsigned int back_stencil_pass_z_pass_operation, unsigned int clear, unsigned int clear_value)
| Constructs a two-sided StencilAttrib.
static RenderAttrib const | makeDefault ()
| Returns a RenderAttrib that corresponds to whatever the standard default properties for render attributes of this type ought to be.
static RenderAttrib const | makeOff ()
| Constructs a StencilAttrib that has stenciling turned off.
static RenderAttrib const | makeWithClear (unsigned int front_enable, unsigned int front_comparison_function, unsigned int stencil_fail_operation, unsigned int stencil_pass_z_fail_operation, unsigned int front_stencil_pass_z_pass_operation, unsigned int reference, unsigned int read_mask, unsigned int write_mask, unsigned int clear, unsigned int clear_value)
| Constructs a front face StencilAttrib.

## Detailed Description

A StencilAttrib is a collection of all stencil render states.

The render states in a StencilAttrib are read-only. A StencilAttrib is created with make or make_2_sided. To determine if two sided stencil is supported, call the function GraphicsStateGuardian:: get_supports_two_sided_stencil.

## Member Enumeration Documentation

enum StencilComparisonFunction

Enumerator:

  SCFNever |
  SCFLessThan |
  SCFEqual |
  SCFLessThanOrEqual |
  SCFGreaterThan |
  SCFNotEqual |
  SCFGreaterThanOrEqual |
  SCFAlways |

enum StencilMask

Enumerator:

  SMDefault |

enum StencilOperation

Enumerator:

  SOKeep |
  SOZero |
  SOReplace |
  SOIncrement |
  SODecrement |
  SOInvert |
  SOIncrementSaturate |
  SODecrementSaturate |

enum StencilRenderState

Enumerator:

  SRSFrontEnable |
  SRSBackEnable |
  SRSFrontComparisonFunction |
  SRSFrontStencilFailOperation |
  SRSFrontStencilPassZFailOperation |
  SRSFrontStencilPassZPassOperation |
  SRSReference |
  SRSReadMask |
  SRSWriteMask |
  SRSBackComparisonFunction |
  SRSBackStencilFailOperation |
  SRSBackStencilPassZFailOperation |
  SRSBackStencilPassZPassOperation |
  SRSClear |
  SRSClearValue |
  SRSTotal |
  SRSFirst |

## Member Function Documentation

static int getClassSlot | ( |  | ) | `[static]`

static TypeHandle getClassType | ( |  | ) | `[static]`

Reimplemented from RenderAttrib.

unsigned int getRenderState | ( | unsigned int | render_state_identifier | ) |

Returns render state.

static RenderAttrib const make | ( | unsigned int | front_enable,
|  | unsigned int | front_comparison_function,
|  | unsigned int | stencil_fail_operation,
|  | unsigned int | stencil_pass_z_fail_operation,
|  | unsigned int | front_stencil_pass_z_pass_operation,
|  | unsigned int | reference,
|  | unsigned int | read_mask,
|  | unsigned int | write_mask
| ) |  | `[static]`

Constructs a front face StencilAttrib.

static RenderAttrib const make2Sided | ( | unsigned int | front_enable,
|  | unsigned int | back_enable,
|  | unsigned int | front_comparison_function,
|  | unsigned int | stencil_fail_operation,
|  | unsigned int | stencil_pass_z_fail_operation,
|  | unsigned int | front_stencil_pass_z_pass_operation,
|  | unsigned int | reference,
|  | unsigned int | read_mask,
|  | unsigned int | write_mask,
|  | unsigned int | back_comparison_function,
|  | unsigned int | back_stencil_fail_operation,
|  | unsigned int | back_stencil_pass_z_fail_operation,
|  | unsigned int | back_stencil_pass_z_pass_operation
| ) |  | `[static]`

Constructs a two-sided StencilAttrib.

static RenderAttrib const make2SidedWithClear | ( | unsigned int | front_enable,
|  | unsigned int | back_enable,
|  | unsigned int | front_comparison_function,
|  | unsigned int | stencil_fail_operation,
|  | unsigned int | stencil_pass_z_fail_operation,
|  | unsigned int | front_stencil_pass_z_pass_operation,
|  | unsigned int | reference,
|  | unsigned int | read_mask,
|  | unsigned int | write_mask,
|  | unsigned int | back_comparison_function,
|  | unsigned int | back_stencil_fail_operation,
|  | unsigned int | back_stencil_pass_z_fail_operation,
|  | unsigned int | back_stencil_pass_z_pass_operation,
|  | unsigned int | clear,
|  | unsigned int | clear_value
| ) |  | `[static]`

Constructs a two-sided StencilAttrib.

static RenderAttrib const makeDefault | ( |  | ) | `[static]`

Returns a RenderAttrib that corresponds to whatever the standard default properties for render attributes of this type ought to be.

static RenderAttrib const makeOff | ( |  | ) | `[static]`

Constructs a StencilAttrib that has stenciling turned off.

static RenderAttrib const makeWithClear | ( | unsigned int | front_enable,
|  | unsigned int | front_comparison_function,
|  | unsigned int | stencil_fail_operation,
|  | unsigned int | stencil_pass_z_fail_operation,
|  | unsigned int | front_stencil_pass_z_pass_operation,
|  | unsigned int | reference,
|  | unsigned int | read_mask,
|  | unsigned int | write_mask,
|  | unsigned int | clear,
|  | unsigned int | clear_value
| ) |  | `[static]`

Constructs a front face StencilAttrib.

All Classes Namespaces Functions Variables Enumerations Enumerator Properties